module EgonGate
  module Egsb
    module Messages
      class E37VyhledejAdresu < Message

        self.attributes = [:obec_nazev, :cast_obce_nazev, :ulice_nazev, :posta_nazev, :posta_kod, :typ_cisla_domovniho_kod, :cislo_domovni, :cislo_orientacni, :cislo_orientacni_pismeno]

        attr_accessor *attributes

        def message_code
          'E37'
        end

        def namespace_definitions
          super.merge({
            'xmlns:nsgon' => 'urn:cz:isvs:iszr:schemas:IszrRuianVyhledejAdresu:v1',
            'xmlns:nscr' => 'urn:cz:isvs:ruian:schemas:VyhledejAdresa:v1'
          })
        end

        def message_tag
          'nsgon:RuianVyhledejAdresu'
        end

        def message_request_tag
          'nsgon:RuianVyhledejAdresuData'
        end

        def message_body
          {
            'nscr:Podminka' => self.class.attributes.each_with_object({}) {|attribute, obj| v = self.public_send(attribute); obj['nscr:'+attribute.to_s.camelize] = v if v }
          }
        end
      end
    end
  end
end
